﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using System.Data.Objects;

namespace EF_Relation_Navigation
{
    class Program
    {
        private static string _connectionString = ConfigurationManager.ConnectionStrings["DemoDbEntities"].ToString();
        public static string ConnectionString
        {
            get
            {
                return _connectionString;
            }
        }
        static void Main(string[] args)
        {
            //Many to one query
            RelNav1();
            Pause(null);

            //One to many query
            RelNav2();
            Pause(null);

        }

        private static void Pause(string message)
        {
            if (null == message)
            {
                message = "Press any key to continue ...";
            }
            Console.WriteLine(message);
            Console.ReadKey(true);
        }

        /// <summary>
        /// This method is used to replace:
        /// SELECT n.Brand, n.Type FROM Notebook as n 
        /// INNER JOIN Warehouse as w
        /// ON n.WarehouseId=w.Id
        /// WHERE w.City='SH'
        /// </summary>
        private static void RelNav1()
        {
            string query = "SELECT VALUE n FROM DemoDbEntities.Notebook AS n"
                         + " WHERE n.Warehouse.City = 'SH'";
            using (ObjectContext oc = new ObjectContext(ConnectionString))
            {
                oc.Connection.Open();
                foreach (Notebook notebook in new ObjectQuery<Notebook>(query, oc))
                {
                    Console.WriteLine("{0} {1}", notebook.Brand, notebook.Type);
                }
            }
        }

        /// <summary>
        /// This method is used t replace:
        /// SELECT DISTINCT w.* FROM Notebook AS n
        /// INNER JOIN Warehouse AS w
        /// ON n.WarehouseId = w.Id
        /// WHERE n.Brand='ThinkPad' OR n.Brand='Lenovo'
        /// </summary>
        private static void RelNav2()
        {
            string query =
                "SELECT VALUE DISTINCT w FROM DemoDbEntities.Warehouse AS w, w.Notebook as nbs " +
                " WHERE nbs.Brand = 'ThinkPad' OR nbs.Brand='Lenovo'";
            using (ObjectContext oc = new ObjectContext(ConnectionString))
            {
                oc.Connection.Open();
                foreach (Warehouse w in new ObjectQuery<Warehouse>(query, oc))
                {
                    Console.WriteLine("{0} {1}", w.Name, w.City);
                }
            }
        }
    }
}
